/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.search.boundary;

import javax.persistence.NoResultException;
import javax.persistence.NonUniqueResultException;
import javax.persistence.EntityNotFoundException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import de.ivu.elect.business.search.entity.BenutzerSuchparameter;
import de.ivu.elect.business.search.entity.BenutzerSuchparameterUK;

public abstract class AbstractBenutzerSuchparameterDAO extends de.ivu.elect.jee.entity.AbstractDAO<BenutzerSuchparameter,
        de.ivu.elect.business.search.entity.BenutzerSuchparameterPK
    , BenutzerSuchparameterUK> {

  private static final long serialVersionUID = 1L;

  private static final Logger LOG = LoggerFactory.getLogger(AbstractBenutzerSuchparameterDAO.class);

  public AbstractBenutzerSuchparameterDAO() {
    super();
  }

  public boolean isEntityWithPKPresent(
            de.ivu.elect.business.search.entity.BenutzerSuchparameterPK
     pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk) != null;
    }

    return false;
  }

  @Override
  public BenutzerSuchparameter findByPrimaryKey(
        de.ivu.elect.business.search.entity.BenutzerSuchparameterPK
      pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk.getId());
    }

    throw new IllegalArgumentException("PK oder PK.getId() ist null! [pk = " + pk + "]");
  }


  @Override
  protected BenutzerSuchparameter findByPrimaryKey(Long id) {
    if (id == null) {
      throw new IllegalArgumentException("ID ist null! [id = " + id + "]");
    }
  return getEntityManager().find(BenutzerSuchparameter.class, id, CACHE_PROPERTIES);
  }



     /**
      * Name: WahlterminBenutzerkennungViewIdNameNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM BenutzerSuchparameter o WHERE o.wahltermin=?1 AND o.benutzerkennung=?2 AND o.viewId=?3 AND o.name=?4<br>
      * SQL: <br>
      */
     public java.util.List<BenutzerSuchparameter> findByWahlterminBenutzerkennungViewIdName( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahltermin wahltermin,  @javax.annotation.Nonnull String benutzerkennung,  @javax.annotation.Nonnull String viewId,  @javax.annotation.Nonnull String name) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahltermin wahlterminCheckedAndAttached =  checkAndAttach(wahltermin, de.ivu.elect.business.wahl.entity.Wahltermin.class, "wahltermin"); ;
		  			  String benutzerkennungCheckedAndAttached =  checkAndAttach(benutzerkennung, String.class, "benutzerkennung"); ;
		  			  String viewIdCheckedAndAttached =  checkAndAttach(viewId, String.class, "viewId"); ;
		  			  String nameCheckedAndAttached =  checkAndAttach(name, String.class, "name"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("BENUTZER_SUCHPARAMETER.WahlterminBenutzerkennungViewIdName")
                              .setParameter(1, wahlterminCheckedAndAttached)
                                        .setParameter(2, benutzerkennungCheckedAndAttached)
                                        .setParameter(3, viewIdCheckedAndAttached)
                                        .setParameter(4, nameCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlterminBenutzerkennungViewIdName - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("BenutzerSuchparameter, findByWahlterminBenutzerkennungViewIdName - NonUniqueResultException, Parameter: "
           + ", wahltermin:'"+wahltermin+"'"
           + ", benutzerkennung:'"+benutzerkennung+"'"
           + ", viewId:'"+viewId+"'"
           + ", name:'"+name+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlterminBenutzerkennungViewIdName(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlterminBenutzerkennungViewIdNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM BenutzerSuchparameter o WHERE o.wahltermin=?1 AND o.benutzerkennung=?2 AND o.viewId=?3 ORDER BY o.name<br>
      * SQL: <br>
      */
     public java.util.List<BenutzerSuchparameter> findByWahlterminBenutzerkennungViewId( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahltermin wahltermin,  @javax.annotation.Nonnull String benutzerkennung,  @javax.annotation.Nonnull String viewId) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahltermin wahlterminCheckedAndAttached =  checkAndAttach(wahltermin, de.ivu.elect.business.wahl.entity.Wahltermin.class, "wahltermin"); ;
		  			  String benutzerkennungCheckedAndAttached =  checkAndAttach(benutzerkennung, String.class, "benutzerkennung"); ;
		  			  String viewIdCheckedAndAttached =  checkAndAttach(viewId, String.class, "viewId"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("BENUTZER_SUCHPARAMETER.WahlterminBenutzerkennungViewId")
                              .setParameter(1, wahlterminCheckedAndAttached)
                                        .setParameter(2, benutzerkennungCheckedAndAttached)
                                        .setParameter(3, viewIdCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlterminBenutzerkennungViewId - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("BenutzerSuchparameter, findByWahlterminBenutzerkennungViewId - NonUniqueResultException, Parameter: "
           + ", wahltermin:'"+wahltermin+"'"
           + ", benutzerkennung:'"+benutzerkennung+"'"
           + ", viewId:'"+viewId+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlterminBenutzerkennungViewId(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlterminWahlBenutzerkennungViewIdNameNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM BenutzerSuchparameter o WHERE o.wahltermin=?1 AND o.wahl=?2 AND o.benutzerkennung=?3 AND o.viewId=?4 AND o.name=?5<br>
      * SQL: <br>
      */
     public java.util.List<BenutzerSuchparameter> findByWahlterminWahlBenutzerkennungViewIdName( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahltermin wahltermin,  @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull String benutzerkennung,  @javax.annotation.Nonnull String viewId,  @javax.annotation.Nonnull String name) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahltermin wahlterminCheckedAndAttached =  checkAndAttach(wahltermin, de.ivu.elect.business.wahl.entity.Wahltermin.class, "wahltermin"); ;
		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  			  String benutzerkennungCheckedAndAttached =  checkAndAttach(benutzerkennung, String.class, "benutzerkennung"); ;
		  			  String viewIdCheckedAndAttached =  checkAndAttach(viewId, String.class, "viewId"); ;
		  			  String nameCheckedAndAttached =  checkAndAttach(name, String.class, "name"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("BENUTZER_SUCHPARAMETER.WahlterminWahlBenutzerkennungViewIdName")
                              .setParameter(1, wahlterminCheckedAndAttached)
                                        .setParameter(2, wahlCheckedAndAttached)
                                        .setParameter(3, benutzerkennungCheckedAndAttached)
                                        .setParameter(4, viewIdCheckedAndAttached)
                                        .setParameter(5, nameCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlterminWahlBenutzerkennungViewIdName - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("BenutzerSuchparameter, findByWahlterminWahlBenutzerkennungViewIdName - NonUniqueResultException, Parameter: "
           + ", wahltermin:'"+wahltermin+"'"
           + ", wahl:'"+wahl+"'"
           + ", benutzerkennung:'"+benutzerkennung+"'"
           + ", viewId:'"+viewId+"'"
           + ", name:'"+name+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlterminWahlBenutzerkennungViewIdName(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlterminWahlBenutzerkennungViewIdNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM BenutzerSuchparameter o WHERE o.wahltermin=?1 AND o.wahl=?2 AND o.benutzerkennung=?3 AND o.viewId=?4 ORDER BY o.name<br>
      * SQL: <br>
      */
     public java.util.List<BenutzerSuchparameter> findByWahlterminWahlBenutzerkennungViewId( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahltermin wahltermin,  @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull String benutzerkennung,  @javax.annotation.Nonnull String viewId) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahltermin wahlterminCheckedAndAttached =  checkAndAttach(wahltermin, de.ivu.elect.business.wahl.entity.Wahltermin.class, "wahltermin"); ;
		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  			  String benutzerkennungCheckedAndAttached =  checkAndAttach(benutzerkennung, String.class, "benutzerkennung"); ;
		  			  String viewIdCheckedAndAttached =  checkAndAttach(viewId, String.class, "viewId"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("BENUTZER_SUCHPARAMETER.WahlterminWahlBenutzerkennungViewId")
                              .setParameter(1, wahlterminCheckedAndAttached)
                                        .setParameter(2, wahlCheckedAndAttached)
                                        .setParameter(3, benutzerkennungCheckedAndAttached)
                                        .setParameter(4, viewIdCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlterminWahlBenutzerkennungViewId - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("BenutzerSuchparameter, findByWahlterminWahlBenutzerkennungViewId - NonUniqueResultException, Parameter: "
           + ", wahltermin:'"+wahltermin+"'"
           + ", wahl:'"+wahl+"'"
           + ", benutzerkennung:'"+benutzerkennung+"'"
           + ", viewId:'"+viewId+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlterminWahlBenutzerkennungViewId(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }



  @Override
  public boolean isEntityWithUKPresent(de.ivu.elect.business.search.entity.BenutzerSuchparameterUK uk) {
    try {
      return findByUK(uk) != null;
    } catch (javax.persistence.NoResultException nre) {
      return false;
    }
  }

  @Override
  public boolean isEntityWithUKHasPK(de.ivu.elect.business.search.entity.BenutzerSuchparameterUK uk,
        de.ivu.elect.business.search.entity.BenutzerSuchparameterPK
      pk

  ) {
    try {
      return findByUK(uk).getPk().equals(pk);
    } catch (NoResultException ignored) {
      // Do nothing - be happy.
    }
    return true;
  }

   public de.ivu.elect.business.search.entity.BenutzerSuchparameter findByUK(de.ivu.elect.business.search.entity.BenutzerSuchparameterUK uk){

    try {
     return (de.ivu.elect.business.search.entity.BenutzerSuchparameter) getEntityManager().createNamedQuery("BENUTZER_SUCHPARAMETER.UK")
                  .setParameter(1, uk
                .getBenutzerkennung ()

              )
             .setParameter(2, uk
                .getName ()

              )
             .setParameter(3, uk
                .getViewId ()

              )
             .setParameter(4, uk
                .getWahlUK ()

                .getWahlartUK ()

                .getName ()

              )
             .setParameter(5, uk
                .getWahlUK ()

                .getWahlartUK ()

                .getMandantUK ()

                .getNummer ()

              )
             .setParameter(6, uk
                .getWahlUK ()

                .getWahlterminUK ()

                .getNummer ()

              )
             .setParameter(7, uk
                .getWahlUK ()

                .getWahlterminUK ()

                .getWahldatum ()

              )
             .setParameter(8, uk
                .getWahlUK ()

                .getWahlterminUK ()

                .getMandantUK ()

                .getNummer ()

              )
             .setParameter(9, uk
                .getWahlterminUK ()

                .getNummer ()

              )
             .setParameter(10, uk
                .getWahlterminUK ()

                .getWahldatum ()

              )
             .setParameter(11, uk
                .getWahlterminUK ()

                .getMandantUK ()

                .getNummer ()

              )
          .getSingleResult()
     ;
     } catch (NonUniqueResultException nure) {
        LOG.warn("BenutzerSuchparameter, findByUK - NonUniqueResultException, UK: " + uk);
        throw nure;
     }
  }
    
}